# std::deque<T,Allocator>::emplace

From cppreference.com
< cpp‎ | container‎ | deque

template< class... Args > iterator emplace( const_iterator pos, Args&&... args ); |  | (since C++11)

Inserts a new element into the container directly before `pos`. The element is constructed through std::allocator_traits::construct, which typically uses placement-new to construct the element in-place at a location provided by the container. The arguments `args...` are forwarded to the constructor as std::forward<Args>(args)....

All iterators, including the past-the-end iterator, are invalidated. References are invalidated too, unless pos == begin() or pos == end(), in which case they are not invalidated.

### Parameters

pos | - | iterator before which the new element will be constructed
args | - | arguments to forward to the constructor of the element
Type requirements
- `T (the container's element type)` must meet the requirements of MoveAssignable, MoveInsertable and EmplaceConstructible.

### Return value

Iterator pointing to the emplaced element.

### Complexity

Linear in the lesser of the distances between `pos` and either of the ends of the container.

### Exceptions

If an exception is thrown other than by the copy constructor, move constructor, assignment operator, or move assignment operator of the value type, or if an exception is thrown while `emplace` is used to insert a single element at the either end, there are no effects (strong exception guarantee).

Otherwise, the effects are unspecified.

### See also

insert | inserts elements (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/deque/emplace&oldid=50454"